curl --request GET \
--url https://api.staging.payrails.io/payment/payments \
--header 'Authorization: Bearer <token>'import requests
url = "https://api.staging.payrails.io/payment/payments"
headers = {"Authorization": "Bearer <token>"}
response = requests.get(url, headers=headers)
print(response.text)const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};
fetch('https://api.staging.payrails.io/payment/payments', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"links": {
"self": "https://api.staging.payrails.io/payment/payments?page[after]=qf7pnbyfrr&page[size]=2",
"prev": "https://api.staging.payrails.io/payment/payments?page[before]=hbe66nh8i8&page[size]=2",
"next": "https://api.staging.payrails.io/payment/payments?page[after]=xk2h55zsy5&page[size]=2",
"first": "https://api.staging.payrails.io/payment/payments?page[size]=2",
"last": "https://api.staging.payrails.io/payment/payments?page[before]=9wkueqcavq&page[size]=2"
},
"results": [
{
"id": "fe67fc45-ce47-4fc8-a283-22d03ae68b77",
"status": "Authorized",
"createdAt": "2022-04-22T17:53:36.814Z",
"providerId": "e96aa893-4458-43c6-b334-179cf73f5dba",
"providerName": "adyen",
"providerDisplayName": "Adyen",
"providerAccountDisplayName": "adyen",
"providerReference": "adyen-6389361285",
"providerConfigId": "5cc8f271-0059-43a3-b339-27712c997e30",
"holderId": "785380c9-1015-453d-82ab-d3386e27c05e",
"amount": {
"value": "22.40",
"currency": "EUR"
},
"instrumentId": "15b0069a-913b-4224-b05a-056e89611a51",
"instrumentTokenId": "38fa0ee2-3f6e-41c1-8298-7398b2a93bd3",
"instrument": {
"id": "15b0069a-913b-4224-b05a-056e89611a51",
"holderId": "788c7c09-a490-4603-915a-e2a957a6cca1",
"createdAt": "2022-04-22T17:53:36.814Z",
"updatedAt": "2022-04-22T17:53:36.814Z",
"paymentMethod": "card",
"description": "Personal card.",
"fingerprint": "739abff0-406a-4d32-8cfb-701e12be5848",
"status": "created",
"futureUsage": "CardOnFile",
"data": {
"network": "visa",
"bin": "411111",
"suffix": "1111",
"expiryMonth": "10",
"expiryYear": "2026",
"holderName": "John Doe"
},
"meta": {
"communityCode": "GAP",
"userKey": "9890124569"
}
},
"transactionReference": "order-671934582",
"transactionElementReference": "wkf-24-64313",
"pspRedirectUrl": "",
"merchantReturnUrl": "http://merchant.com/redirect-from/def456",
"merchantReference": "468b618d77ed",
"workspaceId": "7f9f1882-a103-408d-ac96-46a7021e537a"
},
{
"id": "fe67fc45-ce47-4fc8-a283-22d03ae68b77",
"status": "Canceled",
"createdAt": "2022-04-22T17:53:36.814Z",
"providerId": "e96aa893-4458-43c6-b334-179cf73f5dba",
"providerName": "adyen",
"providerAccountDisplayName": "adyen",
"providerReference": "adyen-6389361285",
"providerConfigId": "5cc8f271-0059-43a3-b339-27712c997e30",
"holderId": "785380c9-1015-453d-82ab-d3386e27c05e",
"amount": {
"value": "22.40",
"currency": "EUR"
},
"instrumentId": "15b0069a-913b-4224-b05a-056e89611a51",
"instrumentTokenId": "38fa0ee2-3f6e-41c1-8298-7398b2a93bd3",
"instrument": {
"id": "15b0069a-913b-4224-b05a-056e89611a51",
"holderId": "788c7c09-a490-4603-915a-e2a957a6cca1",
"createdAt": "2022-04-22T17:53:36.814Z",
"updatedAt": "2022-04-22T17:53:36.814Z",
"paymentMethod": "card",
"description": "Personal card.",
"fingerprint": "739abff0-406a-4d32-8cfb-701e12be5848",
"status": "created",
"futureUsage": "CardOnFile",
"data": {
"network": "visa",
"bin": "411111",
"suffix": "1111",
"expiryMonth": "10",
"expiryYear": "2026",
"holderName": "John Doe"
},
"meta": {
"communityCode": "GAP",
"userKey": "9890124569"
}
},
"transactionReference": "order-671934582",
"transactionElementReference": "wkf-24-64313",
"pspRedirectUrl": "",
"merchantReturnUrl": "http://merchant.com/redirect-from/def456",
"workspaceId": "7f9f1882-a103-408d-ac96-46a7021e537a"
},
{
"id": "fe67fc45-ce47-4fc8-a283-22d03ae68b77",
"status": "Captured",
"createdAt": "2022-04-22T17:53:36.814Z",
"providerId": "e96aa893-4458-43c6-b334-179cf73f5dba",
"providerName": "adyen",
"providerAccountDisplayName": "adyen",
"providerReference": "adyen-6389361285",
"providerConfigId": "5cc8f271-0059-43a3-b339-27712c997e30",
"holderId": "785380c9-1015-453d-82ab-d3386e27c05e",
"amount": {
"value": "22.40",
"currency": "EUR"
},
"instrumentId": "15b0069a-913b-4224-b05a-056e89611a51",
"instrumentTokenId": "38fa0ee2-3f6e-41c1-8298-7398b2a93bd3",
"instrument": {
"id": "15b0069a-913b-4224-b05a-056e89611a51",
"holderId": "788c7c09-a490-4603-915a-e2a957a6cca1",
"createdAt": "2022-04-22T17:53:36.814Z",
"updatedAt": "2022-04-22T17:53:36.814Z",
"paymentMethod": "card",
"description": "Personal card.",
"fingerprint": "739abff0-406a-4d32-8cfb-701e12be5848",
"status": "created",
"futureUsage": "CardOnFile",
"data": {
"network": "visa",
"bin": "411111",
"suffix": "1111",
"expiryMonth": "10",
"expiryYear": "2026",
"holderName": "John Doe"
},
"meta": {
"communityCode": "GAP",
"userKey": "9890124569"
}
},
"transactionReference": "order-671934582",
"transactionElementReference": "wkf-24-64313",
"pspRedirectUrl": "",
"merchantReturnUrl": "http://merchant.com/redirect-from/def456",
"workspaceId": "7f9f1882-a103-408d-ac96-46a7021e537a"
}
]
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.malformed",
"detail": "The request has malformed syntax",
"docUrl": "https://docs.payrails.com/docs/resources/error-codes#requestmalformed"
}
]
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.unauthorized",
"detail": "The request lacks necessary credentials to perform the specified action",
"docUrl": "https://docs.payrails.com/docs/resources/error-codes#requestunauthorized"
}
]
}{
"errors": [
{
"id": "e7db22b3-914e-4975-928e-9edfb0885bea",
"code": "request.forbidden",
"detail": "The request credentials lack the required permissions to perform the specified action",
"docUrl": "https://docs.payrails.com/docs/resources/error-codes#requestforbidden"
}
]
}{
"errors": [
{
"id": "a24bc325-3929-4d9d-9c08-b3aa532685b7",
"code": "request.rate-limit",
"detail": "Too many requests",
"docUrl": "https://docs.payrails.com/docs/resources/error-codes#requestrate-limit"
}
]
}Search & list payments
Fetch a list of payments.
Authorizations
You can use an OAuth2 JWT bearer token in the Authorization header of your API requests for supported endpoints: Authorization: Bearer <YOUR_JWT_HERE>.
These tokens are valid for 10 minutes and can be requested via the access token endpoint endpoint.
Query Parameters
Boolean indicating if the payment instrument should be included in the response.
Boolean indicating if the provider account display name should be included in the response.
Boolean indicating if the instrument payment token should be included in the response.
Boolean indicating if the holder reference should be included in the response.
Filter for a list of payments by payment ID.
Filter for a list of payments by provider ID.
Filter for a list of payments by provider config ID.
Filter for a list of payments by provider reference.
Filter for a list of payments by holder ID.
Filter for a list of payments by holder reference.
Filter for a list of payments by transaction reference.
Filter for a list of payments by merchant reference.
Filter for a list of payments by payment processing type.
Filter for a list of payments by capture mode. Capture mode defines if money is captured instantly, with delay or manually.
Filter for a list of payments by latest payment status.
Filter for a list of payments by any reference.
Filter for a list of payments by instrument token type. Type of the token.
network, vault, psp, networkOffers, networkGateway Filter for a list of payments by instrument ID.
Filter for a list of payments by instrument BIN.
Filter for a list of payments by instrument suffix.
Filter for a list of payments by card network.
Filter for a list of payments by card network.
Filter for a list of payments by instrument issuer.
Filter for a list of payments by instrument issuer country.
Filter for a list of payments by instrument future usage.
Filter for a list of payments by the authorization failure result.
Filter by Workspace ID.
Filter for a list of payments by payment method.
Filter for a list of payments by customer email.
Filter by createdAt field using interval notation.
1973-02-03T04:32:11.596Z - exact date value
(1973-02-03T04:32:11.596Z - after the date excluding it
[1973-02-03T04:32:11.596Z - after the date including it
1973-02-03T04:32:11.596Z) - before the date excluding it
1973-02-03T04:32:11.596Z] - before the date including it
(1973-02-03T04:32:11.596Z,1973-04-03T03:20:11.436Z) - between two dates excluding both
(1973-02-03T04:32:11.596Z,1973-04-03T03:20:11.436Z] - between two dates excluding on the left
[1973-02-03T04:32:11.596Z,1973-04-03T03:20:11.436Z) - between two dates excluding on the right
[1973-02-03T04:32:11.596Z,1973-04-03T03:20:11.436Z] - between two dates including both.
"[2026-04-01T00:00:00Z,2026-05-01T00:00:00Z)"
Search collection items from that cursor. Cursor for paging results.
Search collection items after that cursor. Cursor for paging results.
Search collection items before that cursor. Cursor for paging results.
Length of the collection to search.
Response
Success.
Hide child attributes
Hide child attributes
Unique identifier of the Payment in Payrails.
Exact date and time when the Payment was created in Payrails. Possibly differs slightly from the date in the PSP.
Unique identifier of the Provider that was used to process the Payment.
Type of payment method used to process the payment.
Type of integration used to process the payment (in case the payment provider supports multiple).
Name of the Provider that was used to process the Payment, e.g. Adyen, Checkout, Stripe.
Unique identifier of the Payment in an external system, e.g. PSP.
Unique identifier of the merchant-specific Provider Configuration that was used to process the Payment. This can include the set of credentials used, the merchant account, country, vertical, etc.
Unique identifier of the Holder that is involved in the Payment.
Unique identifier of the Instrument that was used for the Payment in Payrails.
Unique identifier of the specific Token inside the Instrument used for the Payment in Payrails.
Optionally included details about the instrument used for the payment.
Hide child attributes
Hide child attributes
Id of the instrument.
Date and time when the Instrument was created in Payrails.
When the Instrument was last updated.
Unique identifier of the Holder in Payrails.
Represents the payment method type.
alexBankMa7fazty, applePay, audi2pay, bankAccount, card, 2c2p, vietQR, cibSmartWallet, easypaisa, etisalatCash, fawryMobileWallet, fawryPay, googlePay, jazzCash, nbePhoneCash, orangeCash, payPal, qnbEWallet, weCash, genericRedirect, alfa, konnect, eftPro, netBanking, upi, cashFreeWallet, paytmWallet, phonePe, iDeal, bancontact, klarnaPayLater, klarnaPayNow, klarnaPayOverTime, scalapay, payNow, atome Status of the instrument.
created, deleted, enabled, disabled, transient Instrument name suitable for display.
Description of the instrument.
True if this instrument is set as default for the holder.
Merchant-provided reference for the instrument.
System-wide unique identifier of the Instrument. If two Holders have the same instrument stored, this value will be the same for both, but the instrument and token IDs will be different. Cannot be used for payments, should only be used for analytics and fraud prevention.
Represents the future usage to define the payment flows that the stored instrument will be used for.
Subscription, CardOnFile, UnscheduledCardOnFile Identifier of the initial payment made with this instrument on the Networks, e.g. Mastercard Trace ID or Visa Transaction ID.
Mastercard Transaction Link Identifier (TLID) of the transaction series this instrument belongs to. Returned by the card network on the initial cardholder-initiated transaction and required on economically related merchant-initiated transactions, such as recurring payments and installments, when the series spans payment providers.
Type-specific information about the instrument.
- Card
- BankAccount
- PayPal
- GooglePay
- ApplePay
- DCB
- MBWay
Hide child attributes
Hide child attributes
Network of the instrument.
unspecified, visa, visadankort, mastercard, amex, diners, discover, unionpay, unionpayuzcard, maestro, maestrobancontact, hipercard, jcb, jcblankapay, argencard, aura, belkart, bpfuelcard, cabal, carnet, cirrus, chjonesfuelcard, uzcard, codensa, dankort, dinacard, duet, ebt, eftpos, elo, euroshellfuelcard, gecapital, bc, hrgstore, humo, lankapay, lukoilfuelcard, bancontact, meeza, newday, mir, ourocard, pagobancomat, paypak, paypal, phhfuelcard, prostir, rupay, sbercard, sodexo, starrewards, cencosud, naranja, troy, uatp, ukfuelcard, verve, voyager, vpay, wex, cmi, atm, bankcard, localbrand, loyalty, privatelabel, fuelcard, redfuelcard, redliquidfuelcard First 6-8 digits of the Card number. Also known as IIN (Issuer Identification Number).
6 - 8"416598"
Last digits of the Card number.
4Network of the instrument.
unspecified, visa, visadankort, mastercard, amex, diners, discover, unionpay, unionpayuzcard, maestro, maestrobancontact, hipercard, jcb, jcblankapay, argencard, aura, belkart, bpfuelcard, cabal, carnet, cirrus, chjonesfuelcard, uzcard, codensa, dankort, dinacard, duet, ebt, eftpos, elo, euroshellfuelcard, gecapital, bc, hrgstore, humo, lankapay, lukoilfuelcard, bancontact, meeza, newday, mir, ourocard, pagobancomat, paypak, paypal, phhfuelcard, prostir, rupay, sbercard, sodexo, starrewards, cencosud, naranja, troy, uatp, ukfuelcard, verve, voyager, vpay, wex, cmi, atm, bankcard, localbrand, loyalty, privatelabel, fuelcard, redfuelcard, redliquidfuelcard Information about an issuer by the given BIN (or IIN).
Hide child attributes
Hide child attributes
First 6-8 digits of the Card number. Also known as IIN (Issuer Identification Number).
6 - 8"416598"
Network of the instrument.
unspecified, visa, visadankort, mastercard, amex, diners, discover, unionpay, unionpayuzcard, maestro, maestrobancontact, hipercard, jcb, jcblankapay, argencard, aura, belkart, bpfuelcard, cabal, carnet, cirrus, chjonesfuelcard, uzcard, codensa, dankort, dinacard, duet, ebt, eftpos, elo, euroshellfuelcard, gecapital, bc, hrgstore, humo, lankapay, lukoilfuelcard, bancontact, meeza, newday, mir, ourocard, pagobancomat, paypak, paypal, phhfuelcard, prostir, rupay, sbercard, sodexo, starrewards, cencosud, naranja, troy, uatp, ukfuelcard, verve, voyager, vpay, wex, cmi, atm, bankcard, localbrand, loyalty, privatelabel, fuelcard, redfuelcard, redliquidfuelcard Card local network that supports the card, e.g. CartesBancaires, Dankort, Mada, Bancontact.
bancontact, cartesbancaires, dankort, mada Name of the bank or institution that issued the card.
Country of the bank or institution that issued the card.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Segment of the card, e.g. gold, black, business.
Type of the card, e.g. credit, debit, prepaid, gift.
More information about the card type, e.g. personal, commercial.
Indicates whether the card credential represents a network token rather than a primary account number (PAN).
Indicates whether the card is enrolled in a Flexible Credential or Flex Card program supported by the network - e.g. Visa Flexible Credential, Mastercard FlexCard.
Billing Address of the instrument.
Hide child attributes
Hide child attributes
The name of the street of a postal address.
The number on the door, building, or room.
Additional addressing information, 2nd line of postal address.
The name of the suburb or area within a city.
The name of the city of a postal address.
The postal code.
The name of the state a postal address is in.
The country where the address is in.
Hide child attributes
Hide child attributes
ISO 3166-1 alpha-2 country code.
^[A-Z]{2}$ISO 3-letter country code. Returned by Payrails, but not interpreted in requests.
^[A-Z]{3}$The English name of the country. Returned by Payrails, but not interpreted in requests.
Latitude of the address in the GPS coordinate system.
Longitude of the address in the GPS coordinate system.
The phone to contact in the address (can be different that the customer's).
Hide child attributes
Hide child attributes
Name of the address, e.g. home, work.
Name of the person to whom the address belongs to.
Last name of the person to whom the address belongs to.
Email of the person to whom the address belongs to.
Expiry month of the Card.
2Expiry year of the Card.
4Name of the owner of the Card.
Payer-provided tax identification number (e.g. CPF in Brazil) collected on the instrument.
Optionally included details about the instrument token used for the payment.
Hide child attributes
Hide child attributes
Id of the token in Payrails.
Date and time when the Token was created in Payrails.
When the Token was last updated.
Id of the payment instrument the token belongs to.
Status of the token.
created, enabled, disabled, deleted Type of the token.
network, vault, psp, networkOffers, networkGateway Id of the provider the token belongs to.
Unique identifier of the token in the provider's system.
Id of the configuration in the provider the token belongs to.
Any merchant or provider-specific data that should be stored for context in the token.
Merchant-specific identifier of the execution. This can be used for searching for the Payment later.
Identifier of the step in the Workflow that led to this Payment.
In case a redirection process is needed during the Payment, this is the URL where the PSP requested Payrails to redirect the user to.
Amount that was captured from the Payment. If no capture is initiated for the payment, the value will be 0 until a successful capture occurs.
Amount that was refunded from the Payment. If multiple partial refunds have been made, this will be the sum of them. If no refund is initiated for the payment, the value will remain 0 until a successful refund occurs.
Amount still available to refund from the Payment, i.e. capturedAmount minus refundedAmount. Reflects partial captures, so refunds are never allowed to exceed what was actually captured.
In case a redirection process is needed during the Payment, Payrails will return to this merchant-specific URL after it finished.
Merchant-provided reference for the Execution. Commonly, the identifier of the order on the Merchant's system.
Metadata for the context of an execution. Includes Payrails-defined structures for most common fields used in workflows, but can also be extended by merchant or provider-specific fields. For more information, visit our Meta Fields guide. See Meta for every field.
History of Payment Operations executed on the Payment.
Hide child attributes
Hide child attributes
Unique identifier of the Payment Operation in Payrails.
Result of the Operation according to Payrails mapping from the provider response.
Success, Accepted, Pending, HTTPRedirectRequired, FormRedirectRequired, Unknown, UnexpectedProviderResponse, ProviderUnknownError, ProviderConnectionError, Timeout, ProviderTimeout, GenericRejection, FraudRisk, DuplicateOperation, OperationNotAllowed, InstrumentNotAllowed, InvalidInstrument, InsufficientBalance, BlockedInstrument, ExpiredInstrument, ValidationError, ParamsError, ProviderConfigError, InvalidSignature, InternalServerError, PayerCanceled, AuthenticationError, AuthenticationRequired, LimitExceeded, PaymentMethodNotSupported, AuthorizationRevoked Exact date and time when the Payment Operation was created in Payrails. Possibly differs slightly from the date in the PSP.
Exact date and time when the Payment Operation was updated in Payrails. Possibly differs slightly from the date in the PSP.
Unique identifier of the Payment that this Operation belongs to in Payrails.
Operation Type that was executed in the Provider.
Authorize, Preauthorize, Capture, Cancel, Refund, Credit, SendNotification, CaptureNotification, RefundNotification, CancelNotification, AuthorizeNotification, ChargebackNotification, ChargebackReverseNotification, Get, Search, GetToken, Tokenize, DisableToken, Register, Generate3DS, Validate3DS, PayerAuthInit, PayerAuthCheckEnroll, PayerAuthValidate, RefundFailedNotification, RefundReversedNotification, CaptureFailedNotification, ValidateRedirect, RefundNotificationUpdated Reason why the operation was done.
Unique identifier of the Payment Operation in an external system. Some PSPs provide a specific ID for each update in the Payment, but most of them use the same as the original Payment.
The payment status just after the operation done.
Original response code from the PSP, which Payrails interpreted for the result field.
In case a Provider requests an action to continue executing an Operation, this object contains the necessary information for it.
Hide child attributes
Hide child attributes
The URL that the Merchant should redirect the user to.
The HTTP method that should be used when redirecting to the redirectUrl.
GET, POST Map of parameters that are necessary for the redirection. In case the redirectMethod is GET, these parameters can be appended in the query string, but if it's POST, they should be sent via form.
Hide child attributes
Hide child attributes
Error details from the provider.
Acquirer Reference Number (ARN) for the Payment Operation (only Refunds and Captures), which we receive from some of the Provider.
Workspace ID that the workflow configuration belongs to.
List of operation logs associated with this operation.
Hide child attributes
Hide child attributes
Unique identifier of the Payment Operation Log in Payrails.
Exact date and time when the Payment Operation Log was created in Payrails. Possibly differs slightly from the date in the PSP.
Unique identifier of the Payment Operation that this Log belongs to in Payrails.
Original request object sent to the Provider.
Original response object received from the Provider.
Workspace ID that the workflow configuration belongs to.
Latency of the operation on the provider side.
Total latency of the operation.
Display name of the Provider Account/Configuration that was used to process the Payment.
Display name of the Provider that was used to process the Payment.
Workspace ID that the Payment belongs to.